/**
 * This class was created by BrassGoggledCoders modding team.
 * This class is available as part of the BoilerCraft Mod for Minecraft.
 *
 * BoilerCraft is open-source and is distributed under the MMPL v1.0 License.
 * (http://www.mod-buildcraft.com/MMPL-1.0.txt)
 *
 */
package xyz.brassgoggledcoders.boilerplate.common.entity;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

/**
 * @author Surseance
 *
 */
public class EntityMinedBlock extends Entity
{
	public Block block;
	public int metadata;
	public boolean doesRotate;

	public float scale;

	public EntityMinedBlock(World world)
	{
		super(world);
		this.field_70156_m = true;
		this.field_70155_l = 20.0D;
		this.scale = 0.9F;
	}

	public EntityMinedBlock(World world, double x, double y, double z, Block block, int md, boolean rotate)
	{
		super(world);
		this.block = block;
		this.metadata = md;
		this.doesRotate = rotate;
		this.field_70156_m = true;
		// this.setSize(0.98F, 0.98F);
		this.func_70107_b(x, y, z);
		this.field_70159_w = 0.0D;
		this.field_70181_x = 0.0D;
		this.field_70179_y = 0.0D;
		this.field_70169_q = x;
		this.field_70167_r = y;
		this.field_70166_s = z;
		this.scale = 0.9F;
	}

	@Override
	protected boolean func_70041_e_()
	{
		return false;
	}

	@Override
	protected void func_70088_a()
	{
	}

	@Override
	public boolean func_70067_L()
	{
		return false;
	}

	@Override
	public void func_70071_h_()
	{
		super.func_70071_h_();

		if (this.getBlock() != null)
		{
			if ((this.field_70170_p.func_72820_D() % 1) == 0)
			{
				this.scale -= 0.0625F;
			}

			if (this.scale <= 0.0F)
			{
				this.func_70106_y();
			}
		}
	}

	/* TODO: Bounding Box
	@Override
	public AxisAlignedBB getBoundingBox()
	{
		return null;
	}
	*/

	@Override
	protected void func_70014_b(NBTTagCompound tagCompound)
	{
		tagCompound.func_74774_a("Tile", (byte) Block.func_149682_b(this.block));
		tagCompound.func_74768_a("TileID", Block.func_149682_b(this.block));
		tagCompound.func_74774_a("Data", (byte) this.metadata);

		tagCompound.func_74776_a("Scale", this.scale);
	}

	@Override
	protected void func_70037_a(NBTTagCompound tagCompound)
	{
		if (tagCompound.func_150297_b("TileID", 99))
		{
			this.block = Block.func_149729_e(tagCompound.func_74762_e("TileID"));
		}
		else
		{
			this.block = Block.func_149729_e(tagCompound.func_74771_c("Tile") & 255);
		}

		this.metadata = tagCompound.func_74771_c("Data") & 255;
		this.scale = tagCompound.func_74760_g("Scale");
	}

	/* TODO: 1.8 Shadow
	@SideOnly(Side.CLIENT)
	@Override
	public float getShadowSize()
	{
		return 0.0F;
	}
 	*/
	@SideOnly(Side.CLIENT)
	public World getWorldObj()
	{
		return this.field_70170_p;
	}

	@SideOnly(Side.CLIENT)
	@Override
	public boolean func_90999_ad()
	{
		return false;
	}

	public Block getBlock()
	{
		return this.block;
	}
}
