/**
 * This class was created by BrassGoggledCoders modding team.
 * This class is available as part of the BoilerCraft Mod for Minecraft.
 *
 * BoilerCraft is open-source and is distributed under the MMPL v1.0 License.
 * (http://www.mod-buildcraft.com/MMPL-1.0.txt)
 *
 */
package xyz.brassgoggledcoders.boilerplate.common.items;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;

/**
 * @author warlordjones
 *
 */
public abstract class BaseFirearm extends RootItem
{
	protected int damage;
	protected short reloadTime;
	protected boolean twoAmmo;

	protected Item ammo;
	protected Item ammo2;

	protected String fireSound;
	protected String reloadSound;

	public BaseFirearm(int damage, int reloadTime, Item ammo, Item ammo2, String fireSound, String reloadSound)
	{
		super();
		this.damage = damage;
		this.reloadTime = (short) reloadTime;
		this.twoAmmo = ammo2 != null;

		this.ammo = ammo;
		this.ammo2 = ammo2;

		this.fireSound = fireSound;
		this.reloadSound = reloadSound;
		this.func_77625_d(1);
		this.func_77664_n();
	}

	@Override
	public void func_77663_a(ItemStack stack, World world, Entity entity, int par4, boolean par5)
	{
		if ((entity instanceof EntityPlayer) && (((EntityPlayer) entity).func_71045_bC() == stack))
		{
			EntityPlayer player = (EntityPlayer) entity;

			if (!stack.func_77942_o())
			{
				stack.func_77982_d(new NBTTagCompound());
			}

			NBTTagCompound tag = stack.func_77978_p();

			if (tag.func_74765_d("reloadTime") > 0)
			{
				tag.func_74777_a("reloadTime", (short) (tag.func_74765_d("reloadTime") - 1));
				stack.func_77982_d(tag);

				if (tag.func_74765_d("reloadTime") == 10)
				{
					world.func_72956_a(player, this.reloadSound, 0.8F, 1.0F);
				}

			}
		}
	}

	@Override
	/**
	 * called when the player releases the use item button. Args: itemstack,
	 * world, entityplayer, itemInUseCount
	 */
	public ItemStack func_77659_a(ItemStack stack, World world, EntityPlayer player)
	{
		NBTTagCompound tag = stack.func_77978_p();

		if ((tag.func_74765_d("reloadTime") == 0) && player.field_71071_by.func_146028_b(Items.field_151016_H) && player.field_71071_by.func_146028_b(this.ammo))
		{
			if (this.twoAmmo)
			{
				if (player.field_71071_by.func_146028_b(this.ammo2))
				{
					this.shotBullet(stack, world, player);
				}
				player.field_71071_by.func_146026_a(this.ammo2);
			}
			else
			{
				this.shotBullet(stack, world, player);
			}
		}
		return stack;
	}

	protected abstract void shotBullet(ItemStack stack, World world, EntityPlayer player);
}
