package xyz.brassgoggledcoders.boilerplate.common.items;

import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidContainerItem;

/**
 * @author Skylar on 9/2/2015.
 */
public class BaseSteamItem extends RootItem implements IFluidContainerItem
{
	//TODO: Render Stuff
	public int maxSteam;

	public BaseSteamItem(int maxSteam)
	{
		this.maxSteam = maxSteam;
	}

	//Returns True if can the amount is consumed
	protected boolean consumeSteamFromCanister(ItemStack container, int amount)
	{
		boolean canConsume = false;
		if(container != null && container.func_77973_b() instanceof IFluidContainerItem)
		{
			IFluidContainerItem iFluidContainerItem = (IFluidContainerItem)container.func_77973_b();
			if (iFluidContainerItem.getFluid(container).amount > amount)
			{
				iFluidContainerItem.drain(container, amount, true);
				canConsume = true;
			}
		}
		return canConsume;
	}

	@Override
	public FluidStack getFluid(ItemStack container)
	{
		if ((container.func_77978_p() == null) || !container.func_77978_p().func_74764_b("Fluid"))
			return null;
		return FluidStack.loadFluidStackFromNBT(container.func_77978_p().func_74775_l("Fluid"));
	}

	@Override
	public int getCapacity(ItemStack container)
	{
		return this.maxSteam;
	}

	@Override
	public int fill(ItemStack container, FluidStack resource, boolean doFill)
	{
		if (resource == null)
			return 0;

		if (!doFill)
		{
			if ((container.func_77978_p() == null) || !container.func_77978_p().func_74764_b("Fluid"))
				return Math.min(this.maxSteam, resource.amount);

			FluidStack stack = FluidStack.loadFluidStackFromNBT(container.func_77978_p().func_74775_l("Fluid"));

			if (stack == null)
				return Math.min(this.maxSteam, resource.amount);

			if (!stack.isFluidEqual(resource))
				return 0;

			return Math.min(this.maxSteam - stack.amount, resource.amount);
		}

		if (container.func_77978_p() == null)
			container.func_77982_d(new NBTTagCompound());

		if (!container.func_77978_p().func_74764_b("Fluid"))
		{
			NBTTagCompound fluidTag = resource.writeToNBT(new NBTTagCompound());

			if (this.maxSteam < resource.amount)
			{
				fluidTag.func_74768_a("Amount", this.maxSteam);
				container.func_77978_p().func_74782_a("Fluid", fluidTag);
				return this.maxSteam;
			}

			container.func_77978_p().func_74782_a("Fluid", fluidTag);
			return resource.amount;
		}

		NBTTagCompound fluidTag = container.func_77978_p().func_74775_l("Fluid");
		FluidStack stack = FluidStack.loadFluidStackFromNBT(fluidTag);

		if (!stack.isFluidEqual(resource))
			return 0;

		int filled = this.maxSteam - stack.amount;
		if (resource.amount < filled)
		{
			stack.amount += resource.amount;
			filled = resource.amount;
		}
		else
			stack.amount = this.maxSteam;

		container.func_77978_p().func_74782_a("Fluid", stack.writeToNBT(fluidTag));

		return filled;
	}

	@Override
	public FluidStack drain(ItemStack container, int maxDrain, boolean doDrain)
	{
		if ((container.func_77978_p() == null) || !container.func_77978_p().func_74764_b("Fluid"))
			return null;

		FluidStack stack = FluidStack.loadFluidStackFromNBT(container.func_77978_p().func_74775_l("Fluid"));

		if (stack == null)
			return null;

		stack.amount = Math.min(stack.amount, maxDrain);

		if (doDrain)
		{
			if (maxDrain >= this.maxSteam)
			{
				container.func_77978_p().func_82580_o("Fluid");

				if (container.func_77978_p().func_82582_d())
					container.func_77982_d(null);

				return stack;
			}

			NBTTagCompound fluidTag = container.func_77978_p().func_74775_l("Fluid");
			fluidTag.func_74768_a("Amount", fluidTag.func_74762_e("Amount") - stack.amount);
			container.func_77978_p().func_74782_a("Fluid", fluidTag);
		}

		return stack;
	}

	public int getFluidAmount(ItemStack stack)
	{
		FluidStack fluid = this.getFluid(stack);

		if (fluid == null)
			return 0;

		return fluid.amount;
	}

	@Override
	public double getDurabilityForDisplay(ItemStack stack)
	{
		return 1.0D - ((double) this.getFluidAmount(stack) / this.getCapacity(stack));
	}

	@Override
	public boolean showDurabilityBar(ItemStack stack)
	{
		return true;
	}
}
